# set terminal pdfcairo linewidth 3 size 6,3
#set terminal postscript eps linewidth 3 size 6,3
set terminal pslatex size 6.25,2.25 color solid
set output "timing.tex"

set pointsize 2.0
set grid linetype 0
set style data histogram
set style histogram cluster gap 2
set style fill solid border -1
set offset -0.5,-0.35
set boxwidth 0.8

set ylabel "milliseconds"
set key top left reverse Left

set style fill solid noborder
set linetype 1 lc rgb 'black'
set linetype 2 lc rgb 'red'
set linetype 3 lc rgb 'blue'
set linetype 4 lc rgb 'green'

set datafile separator ","
plot for [COL=2:5] 'evaluation/timing.csv' using COL:xticlabels(1) title columnheader
